package com.friday.custody.service.basicService.impl;

import com.friday.custody.entity.DataDictionaryDurationTypeDetailsEntity;
import com.friday.custody.enums.DataDictionaryTypeEnum;
import com.friday.custody.service.basicService.DataDictionaryDurationTypeDetailsService;
import com.friday.custody.service.logicService.DataDictionaryBasicService;
import com.friday.custody.utils.R;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.friday.custody.utils.PageUtils;
import com.friday.custody.utils.Query;

import com.friday.custody.dao.DataDictionaryDurationTypeDao;
import com.friday.custody.entity.DataDictionaryDurationTypeEntity;
import com.friday.custody.service.basicService.DataDictionaryDurationTypeService;
import org.springframework.util.CollectionUtils;


@Service("dataDictionaryDurationTypeService")
public class DataDictionaryDurationTypeServiceImpl extends ServiceImpl<DataDictionaryDurationTypeDao, DataDictionaryDurationTypeEntity>
        implements DataDictionaryDurationTypeService, DataDictionaryBasicService {

    @Override
    public PageUtils queryPage(Map<String, Object> params) {
        IPage<DataDictionaryDurationTypeEntity> page = this.page(
                new Query<DataDictionaryDurationTypeEntity>().getPage(params),
                new QueryWrapper<DataDictionaryDurationTypeEntity>()
        );

        return new PageUtils(page);
    }

    @Autowired
    private DataDictionaryDurationTypeDetailsService detailsService;

    @Override
    public Map<String, String> queryWithDetail(DataDictionaryTypeEnum dicType, String trustNo) {
        return null;
    }


    @Override
    public Map<String, String> queryWithDetail(String trustNo) {
        HashMap<String, String> result = new HashMap<>();
        List<DataDictionaryDurationTypeEntity> allDatas = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(allDatas)) {
            List<DataDictionaryDurationTypeDetailsEntity> detailsEntities = detailsService.selectVByTrustNo(trustNo);
            if (!CollectionUtils.isEmpty(detailsEntities)) {
                Map<String, Integer> originValueKeyMap = detailsEntities.stream().collect(Collectors.toMap(DataDictionaryDurationTypeDetailsEntity::getOriginValue, DataDictionaryDurationTypeDetailsEntity::getDicId));
                Map<Integer, String> idKeyMap = allDatas.stream().collect(Collectors.toMap(DataDictionaryDurationTypeEntity::getId, DataDictionaryDurationTypeEntity::getKeyStr));
                originValueKeyMap.forEach((originValue, id) -> {
                    result.put(originValue, idKeyMap.get(id));
                });
            } else {
                log.error("DataDictionaryFundTypeDetailsEntity 查询失败！");
            }
        } else {
            log.error("DataDictionaryDurationTypeEntity 查询失败！");
        }
        return result;
    }

    @Override
    public R queryData(String type) {
        List<DataDictionaryDurationTypeEntity> entities = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(entities)) {
            return R.ok("查询字典信息成功！")
                    .put("data", entities.stream().collect(Collectors.toMap(DataDictionaryDurationTypeEntity::getKeyStr
                            ,DataDictionaryDurationTypeEntity::getValue)));
        }
        return R.ok("字典信息为空，请联系管理员配置！");
    }
}